# 
#    Copyright 2006 Cybozu Labs, Inc.
#    Copyright 2004,2005 Kazuho Oku
#
#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at
#
#        http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

use strict;
use IPC::Open2;


sub __start_miniserv {
    my ($sin, $sout);
    my $root = $ENV{WEBDB_ROOT} || die "WEBDB_ROOT not set\n";
    $ENV{PERL5OPT} = '';
    local $@;
    eval {
	open2($sin, $sout, "$root/bin/miniserv.pl");
    };
    die "failed to start miniserv.pl" if $@;
    my $port = <$sin>;
    close($sin);
    my $stderr2;
    unless(open($stderr2, ">&", STDERR) &&
	   close(STDERR) &&
	   open(STDERR, ">&" . fileno($sout))) {
	open(STDERR, ">&", $stderr2);
	die "failed to redirect stderr to server";
    }
    close($stderr2);
    chomp($port);
    $ENV{PERLDB_OPTS} = "RemotePort=127.0.0.1:$port";
}

__start_miniserv();
require "perl5db.pl";

1;
