#! /usr/bin/perl
# 
#    Copyright 2006 Cybozu Labs, Inc.
#    Coypright 2004,2005 Kazuho Oku
#
#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at
#
#        http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

use strict;
use CGI qw/:standard/;
use lib '../lib';
use MiniTmpl;


my $file = param('file');

print header(-cache_control => 'no-cache',
	     -pragma => 'no-cache',
	     -expires => 1000000000);

unless ($file) {
    print "file not specified\n";
    exit;
}
if ($file =~ m%^/(dev|etc)%) {
    print "file access forbidden\n";
    exit;
}
unless (-f $file && open(FD, $file)) {
    print "file not found\n";
    exit;
}

my @lines;
my $lineno = 1;
while (my $l = <FD>) {
    $l =~ s/[\r\n]*$//;
    push(@lines, {
	lineno => $lineno,
	line => $l,
	break_imgfile => 'break_off.gif',
    });
    $lineno++;
}
close(FD);

my $tmpl = new MiniTmpl(file => "../template/source.html",
			param => {
			    file => $file,
			    lines => \@lines,
			});
print $tmpl->output();
